diff --git a/drivers/ml/cnxk/cnxk_ml_model.c b/drivers/ml/cnxk/cnxk_ml_model.c
index b069d4e3a5..02f80410ec 100644
--- a/drivers/ml/cnxk/cnxk_ml_model.c
+++ b/drivers/ml/cnxk/cnxk_ml_model.c
@@ -2,11 +2,60 @@
  * Copyright (c) 2023 Marvell.
  */
 
+#include <rte_hash_crc.h>
 #include <rte_mldev.h>
 
 #include "cnxk_ml_model.h"
 #include "cnxk_ml_utils.h"
 
+enum cnxk_ml_model_type
+cnxk_ml_model_get_type(struct rte_ml_model_params *params)
+{
+	struct cn10k_ml_model_metadata_header *metadata_header;
+	enum cnxk_ml_model_type type;
+	uint32_t payload_crc32c;
+	uint32_t header_crc32c;
+
+	type = mvtvm_ml_model_type_get(params);
+	if (type == ML_CNXK_MODEL_TYPE_TVM)
+		return ML_CNXK_MODEL_TYPE_TVM;
+	else if (type == ML_CNXK_MODEL_TYPE_INVALID)
+		return ML_CNXK_MODEL_TYPE_INVALID;
+
+	/* Check model magic string */
+	metadata_header = (struct cn10k_ml_model_metadata_header *)params->addr;
+	if (strncmp((char *)metadata_header->magic, MRVL_ML_MODEL_MAGIC_STRING, 4) != 0) {
+		plt_err("Invalid Glow model, magic = %s", metadata_header->magic);
+		return ML_CNXK_MODEL_TYPE_INVALID;
+	}
+
+	/* Header CRC check */
+	if (metadata_header->header_crc32c != 0) {
+		header_crc32c = rte_hash_crc(
+			params->addr,
+			sizeof(struct cn10k_ml_model_metadata_header) - sizeof(uint32_t), 0);
+
+		if (header_crc32c != metadata_header->header_crc32c) {
+			plt_err("Invalid Glow model, Header CRC mismatch");
+			return ML_CNXK_MODEL_TYPE_INVALID;
+		}
+	}
+
+	/* Payload CRC check */
+	if (metadata_header->payload_crc32c != 0) {
+		payload_crc32c = rte_hash_crc(
+			PLT_PTR_ADD(params->addr, sizeof(struct cn10k_ml_model_metadata_header)),
+			params->size - sizeof(struct cn10k_ml_model_metadata_header), 0);
+
+		if (payload_crc32c != metadata_header->payload_crc32c) {
+			plt_err("Invalid Glow model, Payload CRC mismatch");
+			return ML_CNXK_MODEL_TYPE_INVALID;
+		}
+	}
+
+	return ML_CNXK_MODEL_TYPE_GLOW;
+}
+
 void
 cnxk_ml_model_dump(struct cnxk_ml_dev *cnxk_mldev, struct cnxk_ml_model *model, FILE *fp)
 {
diff --git a/drivers/ml/cnxk/cnxk_ml_model.h b/drivers/ml/cnxk/cnxk_ml_model.h
index f100eca203..a2fced46a2 100644
--- a/drivers/ml/cnxk/cnxk_ml_model.h
+++ b/drivers/ml/cnxk/cnxk_ml_model.h
@@ -13,6 +13,8 @@
 
 #ifdef RTE_MLDEV_CNXK_ENABLE_MVTVM
 #include "mvtvm_ml_model.h"
+#else
+#include "mvtvm_ml_stubs.h"
 #endif
 
 #include "cnxk_ml_io.h"
@@ -184,6 +186,7 @@ struct cnxk_ml_model {
 	set_poll_addr_t set_poll_addr;
 };
 
+enum cnxk_ml_model_type cnxk_ml_model_get_type(struct rte_ml_model_params *params);
 void cnxk_ml_model_dump(struct cnxk_ml_dev *cnxk_mldev, struct cnxk_ml_model *model, FILE *fp);
 
 #endif /* _CNXK_ML_MODEL_H_ */
diff --git a/drivers/ml/cnxk/cnxk_ml_ops.c b/drivers/ml/cnxk/cnxk_ml_ops.c
index ea6f59a70f..c140408023 100644
--- a/drivers/ml/cnxk/cnxk_ml_ops.c
+++ b/drivers/ml/cnxk/cnxk_ml_ops.c
@@ -1018,6 +1018,7 @@ cnxk_ml_model_load(struct rte_ml_dev *dev, struct rte_ml_model_params *params, u
 {
 	struct rte_ml_dev_info dev_info;
 	struct cnxk_ml_dev *cnxk_mldev;
+	enum cnxk_ml_model_type type;
 	struct cnxk_ml_model *model;
 
 	char str[RTE_MEMZONE_NAMESIZE];
@@ -1033,6 +1034,12 @@ cnxk_ml_model_load(struct rte_ml_dev *dev, struct rte_ml_model_params *params, u
 
 	cnxk_mldev = dev->data->dev_private;
 
+	type = cnxk_ml_model_get_type(params);
+	if (type == ML_CNXK_MODEL_TYPE_INVALID) {
+		plt_err("Invalid / unsupported model type");
+		return -EINVAL;
+	}
+
 	/* Find model ID */
 	found = false;
 	for (lcl_model_id = 0; lcl_model_id < dev->data->nb_models; lcl_model_id++) {
@@ -1066,6 +1073,7 @@ cnxk_ml_model_load(struct rte_ml_dev *dev, struct rte_ml_model_params *params, u
 
 	model = mz->addr;
 	model->cnxk_mldev = cnxk_mldev;
+	model->type = type;
 	model->model_id = lcl_model_id;
 	model->info = PLT_PTR_ADD(
 		model, PLT_ALIGN_CEIL(sizeof(struct cnxk_ml_model), dev_info.align_size));
diff --git a/drivers/ml/cnxk/meson.build b/drivers/ml/cnxk/meson.build
index 12b73ee3be..b3a62a7871 100644
--- a/drivers/ml/cnxk/meson.build
+++ b/drivers/ml/cnxk/meson.build
@@ -9,6 +9,11 @@ endif
 
 enable_mvtvm = true
 
+if not libarchive.found()
+        message('drivers/ml/cnxk: libarchive not found')
+        enable_mvtvm = false
+endif
+
 if not jansson_dep.found()
         message('drivers/ml/cnxk: jansson not found')
         enable_mvtvm = false
@@ -71,6 +76,7 @@ driver_sdk_headers += files(
 
 sources += files(
         'mvtvm_ml_ops.c',
+        'mvtvm_ml_model.c',
 )
 
 ext_deps += tvmrt_dep
diff --git a/drivers/ml/cnxk/mvtvm_ml_model.c b/drivers/ml/cnxk/mvtvm_ml_model.c
new file mode 100644
index 0000000000..ab5f8baa67
--- /dev/null
+++ b/drivers/ml/cnxk/mvtvm_ml_model.c
@@ -0,0 +1,55 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Marvell.
+ */
+
+#include <archive.h>
+#include <archive_entry.h>
+
+#include <rte_mldev.h>
+
+#include <roc_api.h>
+
+#include "cnxk_ml_model.h"
+
+/* Objects list */
+char mvtvm_object_list[ML_MVTVM_MODEL_OBJECT_MAX][RTE_ML_STR_MAX] = {"mod.so", "mod.json",
+								     "mod.params"};
+
+enum cnxk_ml_model_type
+mvtvm_ml_model_type_get(struct rte_ml_model_params *params)
+{
+	bool object_found[ML_MVTVM_MODEL_OBJECT_MAX] = {false, false, false};
+	struct archive_entry *entry;
+	struct archive *a;
+	uint8_t i;
+	int ret;
+
+	/* Assume as archive and check for read status */
+	a = archive_read_new();
+	archive_read_support_filter_all(a);
+	archive_read_support_format_all(a);
+
+	ret = archive_read_open_memory(a, params->addr, params->size);
+	if (ret != ARCHIVE_OK)
+		return ML_CNXK_MODEL_TYPE_UNKNOWN;
+
+	/* Parse buffer for available objects */
+	while (archive_read_next_header(a, &entry) == ARCHIVE_OK) {
+		for (i = 0; i < ML_MVTVM_MODEL_OBJECT_MAX; i++) {
+			if (!object_found[i] &&
+			    (strcmp(archive_entry_pathname(entry), mvtvm_object_list[i]) == 0))
+				object_found[i] = true;
+		}
+		archive_read_data_skip(a);
+	}
+
+	/* Check if all objects are available */
+	for (i = 0; i < ML_MVTVM_MODEL_OBJECT_MAX; i++) {
+		if (!object_found[i]) {
+			plt_err("Object %s not found in archive!\n", mvtvm_object_list[i]);
+			return ML_CNXK_MODEL_TYPE_INVALID;
+		}
+	}
+
+	return ML_CNXK_MODEL_TYPE_TVM;
+}
diff --git a/drivers/ml/cnxk/mvtvm_ml_model.h b/drivers/ml/cnxk/mvtvm_ml_model.h
index 1f6b435be0..b6162fceec 100644
--- a/drivers/ml/cnxk/mvtvm_ml_model.h
+++ b/drivers/ml/cnxk/mvtvm_ml_model.h
@@ -43,4 +43,6 @@ struct mvtvm_ml_model_data {
 	struct cnxk_ml_io_info info;
 };
 
+enum cnxk_ml_model_type mvtvm_ml_model_type_get(struct rte_ml_model_params *params);
+
 #endif /* _MVTVM_ML_MODEL_H_ */
diff --git a/drivers/ml/cnxk/mvtvm_ml_stubs.c b/drivers/ml/cnxk/mvtvm_ml_stubs.c
index a31cd39cfa..a7352840a6 100644
--- a/drivers/ml/cnxk/mvtvm_ml_stubs.c
+++ b/drivers/ml/cnxk/mvtvm_ml_stubs.c
@@ -7,6 +7,15 @@
 #include "mvtvm_ml_stubs.h"
 
 #include "cnxk_ml_dev.h"
+#include "cnxk_ml_model.h"
+
+enum cnxk_ml_model_type
+mvtvm_ml_model_type_get(struct rte_ml_model_params *params)
+{
+	RTE_SET_USED(params);
+
+	return ML_CNXK_MODEL_TYPE_UNKNOWN;
+}
 
 int
 mvtvm_ml_dev_configure(struct cnxk_ml_dev *cnxk_mldev, const struct rte_ml_dev_config *conf)
diff --git a/drivers/ml/cnxk/mvtvm_ml_stubs.h b/drivers/ml/cnxk/mvtvm_ml_stubs.h
index 11c56e5144..467a9d39e5 100644
--- a/drivers/ml/cnxk/mvtvm_ml_stubs.h
+++ b/drivers/ml/cnxk/mvtvm_ml_stubs.h
@@ -9,6 +9,7 @@
 
 struct cnxk_ml_dev;
 
+enum cnxk_ml_model_type mvtvm_ml_model_type_get(struct rte_ml_model_params *params);
 int mvtvm_ml_dev_configure(struct cnxk_ml_dev *cnxk_mldev, const struct rte_ml_dev_config *conf);
 int mvtvm_ml_dev_close(struct cnxk_ml_dev *cnxk_mldev);
 